Generalize functions used by both hspace and hcheck
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34
35 # Note: these are automake-specific variables, and must be named after
36 # the directory + 'dir' suffix
37 clientdir = $(pkgpythondir)/client
38 hypervisordir = $(pkgpythondir)/hypervisor
39 httpdir = $(pkgpythondir)/http
40 masterddir = $(pkgpythondir)/masterd
41 confddir = $(pkgpythondir)/confd
42 rapidir = $(pkgpythondir)/rapi
43 serverdir = $(pkgpythondir)/server
44 watcherdir = $(pkgpythondir)/watcher
45 impexpddir = $(pkgpythondir)/impexpd
46 utilsdir = $(pkgpythondir)/utils
47 toolsdir = $(pkglibdir)/tools
48 iallocatorsdir = $(pkglibdir)/iallocators
49 pytoolsdir = $(pkgpythondir)/tools
50 docdir = $(datadir)/doc/$(PACKAGE)
51 myexeclibdir = $(pkglibdir)
52
53 # Delete output file if an error occurred while building it
54 .DELETE_ON_ERROR:
55
56 HTOOLS_DIRS = \
57         htools \
58         htools/Ganeti \
59         htools/Ganeti/Confd \
60         htools/Ganeti/HTools \
61         htools/Ganeti/HTools/Program
62
63 DIRS = \
64         autotools \
65         daemons \
66         devel \
67         doc \
68         doc/examples \
69         doc/examples/hooks \
70         doc/examples/gnt-debug \
71         $(HTOOLS_DIRS) \
72         lib \
73         lib/client \
74         lib/build \
75         lib/confd \
76         lib/http \
77         lib/hypervisor \
78         lib/impexpd \
79         lib/masterd \
80         lib/rapi \
81         lib/server \
82         lib/tools \
83         lib/utils \
84         lib/watcher \
85         man \
86         qa \
87         test \
88         test/data \
89         test/data/htools \
90         test/data/htools/rapi \
91         test/data/ovfdata \
92         test/data/ovfdata/other \
93         tools
94
95 BUILDTIME_DIR_AUTOCREATE = \
96         scripts \
97         $(APIDOC_DIR) \
98         $(APIDOC_PY_DIR) \
99         $(APIDOC_HS_DIR) \
100         $(APIDOC_HS_DIR)/Ganeti \
101         $(APIDOC_HS_DIR)/Ganeti/Confd \
102         $(APIDOC_HS_DIR)/Ganeti/HTools \
103         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
104         $(COVERAGE_DIR) \
105         $(COVERAGE_PY_DIR) \
106         $(COVERAGE_HS_DIR) \
107         .hpc
108
109 BUILDTIME_DIRS = \
110         $(BUILDTIME_DIR_AUTOCREATE) \
111         doc/html
112
113 DIRCHECK_EXCLUDE = \
114         $(BUILDTIME_DIRS) \
115         ganeti-[0-9]*.[0-9]*.[0-9]* \
116         doc/html/_*
117
118 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
119
120 # some helper vars
121 COVERAGE_DIR = doc/coverage
122 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
123 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
124 APIDOC_DIR = doc/api
125 APIDOC_PY_DIR = $(APIDOC_DIR)/py
126 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
127
128 MAINTAINERCLEANFILES = \
129         $(docpng) \
130         $(maninput) \
131         doc/install-quick.rst \
132         doc/news.rst \
133         doc/upgrade.rst \
134         vcs-version
135
136 maintainer-clean-local:
137         rm -rf $(BUILDTIME_DIRS)
138
139 CLEANFILES = \
140         $(addsuffix /*.py[co],$(DIRS)) \
141         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
142         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
143         $(all_dirfiles) \
144         $(PYTHON_BOOTSTRAP) \
145         epydoc.conf \
146         autotools/replace_vars.sed \
147         daemons/daemon-util \
148         daemons/ganeti-cleaner \
149         devel/upload \
150         $(BUILT_EXAMPLES) \
151         doc/examples/bash_completion \
152         lib/_generated_rpc.py \
153         $(man_MANS) \
154         $(manhtml) \
155         tools/kvm-ifup \
156         stamp-srclinks \
157         $(nodist_pkgpython_PYTHON) \
158         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
159         $(HS_BUILT_TEST_HELPERS) \
160         .hpc/*.mix htools/*.tix \
161         doc/hs-lint.html
162
163 # BUILT_SOURCES should only be used as a dependency on phony
164 # targets. Otherwise it'll cause the target to rebuild every time.
165 BUILT_SOURCES = \
166   $(built_base_sources) \
167         $(BUILT_PYTHON_SOURCES) \
168         $(PYTHON_BOOTSTRAP)
169
170 built_base_sources = \
171         ganeti \
172         stamp-srclinks \
173         $(all_dirfiles)
174
175 built_python_base_sources = \
176         lib/_autoconf.py \
177         lib/_vcsversion.py
178
179 BUILT_PYTHON_SOURCES = \
180         $(built_python_base_sources) \
181         lib/_generated_rpc.py
182
183 # Generating the RPC wrappers depends on many things, so make sure it's built at
184 # the end of the built sources
185 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
186
187 # these are all built from the underlying %.in sources
188 BUILT_EXAMPLES = \
189         doc/examples/ganeti-kvm-poweroff.initd \
190         doc/examples/ganeti.cron \
191         doc/examples/ganeti.initd \
192         doc/examples/gnt-config-backup \
193         doc/examples/hooks/ipsec
194
195 nodist_pkgpython_PYTHON = \
196         $(BUILT_PYTHON_SOURCES)
197
198 noinst_PYTHON = \
199         lib/build/__init__.py \
200         lib/build/sphinx_ext.py \
201         lib/build/shell_example_lexer.py
202
203 pkgpython_PYTHON = \
204         lib/__init__.py \
205         lib/asyncnotifier.py \
206         lib/backend.py \
207         lib/bdev.py \
208         lib/bootstrap.py \
209         lib/cli.py \
210         lib/cmdlib.py \
211         lib/compat.py \
212         lib/config.py \
213         lib/constants.py \
214         lib/daemon.py \
215         lib/errors.py \
216         lib/ht.py \
217         lib/jqueue.py \
218         lib/jstore.py \
219         lib/locking.py \
220         lib/luxi.py \
221         lib/mcpu.py \
222         lib/netutils.py \
223         lib/objects.py \
224         lib/opcodes.py \
225         lib/ovf.py \
226         lib/qlang.py \
227         lib/query.py \
228         lib/rpc.py \
229         lib/rpc_defs.py \
230         lib/runtime.py \
231         lib/serializer.py \
232         lib/ssconf.py \
233         lib/ssh.py \
234         lib/storage.py \
235         lib/uidpool.py \
236         lib/workerpool.py
237
238 client_PYTHON = \
239         lib/client/__init__.py \
240         lib/client/gnt_backup.py \
241         lib/client/gnt_cluster.py \
242         lib/client/gnt_debug.py \
243         lib/client/gnt_group.py \
244         lib/client/gnt_instance.py \
245         lib/client/gnt_job.py \
246         lib/client/gnt_node.py \
247         lib/client/gnt_os.py
248
249 hypervisor_PYTHON = \
250         lib/hypervisor/__init__.py \
251         lib/hypervisor/hv_base.py \
252         lib/hypervisor/hv_chroot.py \
253         lib/hypervisor/hv_fake.py \
254         lib/hypervisor/hv_kvm.py \
255         lib/hypervisor/hv_lxc.py \
256         lib/hypervisor/hv_xen.py
257
258 rapi_PYTHON = \
259         lib/rapi/__init__.py \
260         lib/rapi/baserlib.py \
261         lib/rapi/client.py \
262         lib/rapi/client_utils.py \
263         lib/rapi/connector.py \
264         lib/rapi/rlib2.py \
265         lib/rapi/testutils.py
266
267 http_PYTHON = \
268         lib/http/__init__.py \
269         lib/http/auth.py \
270         lib/http/client.py \
271         lib/http/server.py
272
273 confd_PYTHON = \
274         lib/confd/__init__.py \
275         lib/confd/client.py \
276         lib/confd/querylib.py \
277         lib/confd/server.py
278
279 masterd_PYTHON = \
280         lib/masterd/__init__.py \
281         lib/masterd/instance.py
282
283 impexpd_PYTHON = \
284         lib/impexpd/__init__.py
285
286 watcher_PYTHON = \
287         lib/watcher/__init__.py \
288         lib/watcher/nodemaint.py \
289         lib/watcher/state.py
290
291 server_PYTHON = \
292         lib/server/__init__.py \
293         lib/server/confd.py \
294         lib/server/masterd.py \
295         lib/server/noded.py \
296         lib/server/rapi.py
297
298 pytools_PYTHON = \
299         lib/tools/__init__.py \
300         lib/tools/ensure_dirs.py
301
302 utils_PYTHON = \
303         lib/utils/__init__.py \
304         lib/utils/algo.py \
305         lib/utils/filelock.py \
306         lib/utils/hash.py \
307         lib/utils/io.py \
308         lib/utils/log.py \
309         lib/utils/mlock.py \
310         lib/utils/nodesetup.py \
311         lib/utils/process.py \
312         lib/utils/retry.py \
313         lib/utils/text.py \
314         lib/utils/wrapper.py \
315         lib/utils/x509.py
316
317 docrst = \
318         doc/admin.rst \
319         doc/design-2.0.rst \
320         doc/design-2.1.rst \
321         doc/design-2.2.rst \
322         doc/design-2.3.rst \
323         doc/design-htools-2.3.rst \
324         doc/design-2.4.rst \
325         doc/design-2.5.rst \
326         doc/design-draft.rst \
327         doc/design-oob.rst \
328         doc/design-cpu-pinning.rst \
329         doc/design-query2.rst \
330         doc/design-x509-ca.rst \
331         doc/design-http-server.rst \
332         doc/design-impexp2.rst \
333         doc/design-lu-generated-jobs.rst \
334         doc/design-multi-reloc.rst \
335         doc/design-network.rst \
336         doc/design-chained-jobs.rst \
337         doc/design-ovf-support.rst \
338         doc/design-resource-model.rst \
339         doc/cluster-merge.rst \
340         doc/design-shared-storage.rst \
341         doc/design-node-state-cache.rst \
342         doc/design-virtual-clusters.rst \
343         doc/devnotes.rst \
344         doc/glossary.rst \
345         doc/hooks.rst \
346         doc/iallocator.rst \
347         doc/index.rst \
348         doc/install-quick.rst \
349         doc/install.rst \
350         doc/locking.rst \
351         doc/move-instance.rst \
352         doc/news.rst \
353         doc/rapi.rst \
354         doc/security.rst \
355         doc/upgrade.rst \
356         doc/walkthrough.rst
357
358 HS_PROGS = htools/htools
359 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
360
361 HS_ALL_PROGS = $(HS_PROGS) htools/test htools/hpc-htools htools/hconfd
362 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
363 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/%) test/hail
364
365 HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
366 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
367 HEXTRA =
368 # internal extra flags (used for htools/test mainly)
369 HEXTRA_INT =
370 # exclude options for coverage reports
371 HPCEXCL = --exclude Main \
372         --exclude Ganeti.Constants \
373         --exclude Ganeti.THH \
374         --exclude Ganeti.HTools.QC \
375         --exclude Ganeti.HTools.QCHelper \
376         --exclude Ganeti.HTools.Version
377
378 HS_LIB_SRCS = \
379         htools/Ganeti/HTools/CLI.hs \
380         htools/Ganeti/HTools/Cluster.hs \
381         htools/Ganeti/HTools/Compat.hs \
382         htools/Ganeti/HTools/Container.hs \
383         htools/Ganeti/HTools/ExtLoader.hs \
384         htools/Ganeti/HTools/Group.hs \
385         htools/Ganeti/HTools/IAlloc.hs \
386         htools/Ganeti/HTools/Instance.hs \
387         htools/Ganeti/HTools/JSON.hs \
388         htools/Ganeti/HTools/Loader.hs \
389         htools/Ganeti/HTools/Luxi.hs \
390         htools/Ganeti/HTools/Node.hs \
391         htools/Ganeti/HTools/PeerMap.hs \
392         htools/Ganeti/HTools/QC.hs \
393         htools/Ganeti/HTools/QCHelper.hs \
394         htools/Ganeti/HTools/Rapi.hs \
395         htools/Ganeti/HTools/Simu.hs \
396         htools/Ganeti/HTools/Text.hs \
397         htools/Ganeti/HTools/Types.hs \
398         htools/Ganeti/HTools/Utils.hs \
399         htools/Ganeti/HTools/Program.hs \
400         htools/Ganeti/HTools/Program/Hail.hs \
401         htools/Ganeti/HTools/Program/Hbal.hs \
402         htools/Ganeti/HTools/Program/Hcheck.hs \
403         htools/Ganeti/HTools/Program/Hinfo.hs \
404         htools/Ganeti/HTools/Program/Hscan.hs \
405         htools/Ganeti/HTools/Program/Hspace.hs \
406         htools/Ganeti/BasicTypes.hs \
407         htools/Ganeti/Confd.hs \
408         htools/Ganeti/Confd/Server.hs \
409         htools/Ganeti/Config.hs \
410         htools/Ganeti/Daemon.hs \
411         htools/Ganeti/Hash.hs \
412         htools/Ganeti/Jobs.hs \
413         htools/Ganeti/Logging.hs \
414         htools/Ganeti/Luxi.hs \
415         htools/Ganeti/Objects.hs \
416         htools/Ganeti/OpCodes.hs \
417         htools/Ganeti/Runtime.hs \
418         htools/Ganeti/Ssconf.hs \
419         htools/Ganeti/THH.hs
420
421 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
422 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
423
424 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
425
426 # Note: we use here an order-only prerequisite, as the contents of
427 # _autoconf.py are not actually influencing the html build output: it
428 # has to exist in order for the sphinx module to be loaded
429 # successfully, but we certainly don't want the docs to be rebuilt if
430 # it changes
431 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
432         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
433         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
434         | $(BUILT_PYTHON_SOURCES)
435         @test -n "$(SPHINX)" || \
436             { echo 'sphinx-build' not found during configure; exit 1; }
437         @mkdir_p@ $(dir $@)
438         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
439             -d . \
440             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
441             -D release="$(PACKAGE_VERSION)" \
442             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
443         rm -f doc/html/.buildinfo doc/html/objects.inv
444         touch $@
445
446 doc/html: doc/html/index.html
447
448 doc/install-quick.rst: INSTALL
449 doc/news.rst: NEWS
450 doc/upgrade.rst: UPGRADE
451
452 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
453         set -e; \
454         { echo '.. This file is automatically updated at build time from $<.'; \
455           echo '.. Do not edit.'; \
456           echo; \
457           cat $<; \
458         } > $@
459
460 docdot = \
461         doc/arch-2.0.dot \
462         doc/design-2.1-lock-acquire.dot \
463         doc/design-2.1-lock-release.dot
464
465 docpng = $(patsubst %.dot,%.png,$(docdot))
466
467 # Things to build but not to install (add it to EXTRA_DIST if it should be
468 # distributed)
469 noinst_DATA = \
470         devel/upload \
471         doc/html \
472         $(BUILT_EXAMPLES) \
473         doc/examples/bash_completion \
474         $(manhtml)
475
476 gnt_scripts = \
477         scripts/gnt-backup \
478         scripts/gnt-cluster \
479         scripts/gnt-debug \
480         scripts/gnt-group \
481         scripts/gnt-instance \
482         scripts/gnt-job \
483         scripts/gnt-node \
484         scripts/gnt-os
485
486 PYTHON_BOOTSTRAP_SBIN = \
487         daemons/ganeti-masterd \
488         daemons/ganeti-noded \
489         daemons/ganeti-watcher \
490         daemons/ganeti-rapi \
491         $(gnt_scripts)
492
493 if PY_CONFD
494 PYTHON_BOOTSTRAP_SBIN += daemons/ganeti-confd
495 endif
496
497 PYTHON_BOOTSTRAP = \
498         $(PYTHON_BOOTSTRAP_SBIN) \
499         tools/ensure-dirs
500
501 qa_scripts = \
502         qa/__init__.py \
503         qa/ganeti-qa.py \
504         qa/qa_cluster.py \
505         qa/qa_config.py \
506         qa/qa_daemon.py \
507         qa/qa_env.py \
508         qa/qa_error.py \
509         qa/qa_group.py \
510         qa/qa_instance.py \
511         qa/qa_job.py \
512         qa/qa_node.py \
513         qa/qa_os.py \
514         qa/qa_rapi.py \
515         qa/qa_tags.py \
516         qa/qa_utils.py
517
518 bin_SCRIPTS =
519 if WANT_HTOOLS
520 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
521 install-exec-hook:
522         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
523 # FIXME: this is a hardcoded logic, instead of auto-resolving
524         $(LN_S) -f ../../../bin/htools \
525                    $(DESTDIR)$(iallocatorsdir)/hail
526         for role in $(HS_BIN_ROLES); do \
527                 $(LN_S) -f htools \
528                            $(DESTDIR)$(bindir)/$$role ; \
529         done
530 if HS_CONFD
531         mv $(DESTDIR)$(sbindir)/hconfd $(DESTDIR)$(sbindir)/ganeti-confd
532 endif
533 endif
534
535 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
536         @if [ -z "$(HTOOLS)" ]; then \
537           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
538           exit 1; \
539         fi
540         @BINARY=$(@:htools/%=%); \
541         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
542           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
543           exit 1; \
544         fi
545         rm -f $(@:htools/%=%).tix
546         BINARY=$(@:htools/%=%); $(GHC) --make \
547           $(HFLAGS) \
548           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
549           -osuf $$BINARY.o -hisuf $$BINARY.hi \
550           $(HEXTRA) $(HEXTRA_INT) $@
551 # for the htools/test binary, we need to enable profiling/coverage
552 htools/test: HEXTRA_INT=-fhpc -Wwarn -fno-warn-missing-signatures \
553         -fno-warn-monomorphism-restriction -fno-warn-orphans \
554         -fno-warn-missing-methods -fno-warn-unused-imports
555
556 # we compile the hpc-htools binary with the program coverage
557 htools/hpc-htools: HEXTRA_INT=-fhpc
558
559 # test dependency
560 htools/offline-tests.sh: htools/hpc-htools
561
562 # rules for building profiling-enabled versions of the haskell
563 # programs: hs-prof does the full two-step build, whereas
564 # hs-prof-quick does only the final rebuild (hs-prof must have been
565 # run before)
566 .PHONY: hs-prof hs-prof-quick
567 hs-prof:
568         $(MAKE) clean
569         $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
570         rm -f $(HS_ALL_PROGS)
571         $(MAKE) hs-prof-quick
572
573 hs-prof-quick:
574         $(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
575
576 dist_sbin_SCRIPTS = \
577         tools/ganeti-listrunner
578
579 nodist_sbin_SCRIPTS = \
580         $(PYTHON_BOOTSTRAP_SBIN) \
581         daemons/ganeti-cleaner
582
583 if HS_CONFD
584 nodist_sbin_SCRIPTS += htools/hconfd
585 endif
586
587 python_scripts = \
588         tools/burnin \
589         tools/cfgshell \
590         tools/cfgupgrade \
591         tools/cfgupgrade12 \
592         tools/cluster-merge \
593         tools/confd-client \
594         tools/fmtjson \
595         tools/lvmstrap \
596         tools/move-instance \
597         tools/ovfconverter \
598         tools/setup-ssh \
599         tools/sanitize-config
600
601 dist_tools_SCRIPTS = \
602         $(python_scripts) \
603         tools/kvm-console-wrapper \
604         tools/xm-console-wrapper \
605         tools/master-ip-setup
606
607 pkglib_python_scripts = \
608         daemons/import-export \
609         tools/check-cert-expired
610
611 nodist_pkglib_python_scripts = \
612         tools/ensure-dirs
613
614 myexeclib_SCRIPTS = \
615         daemons/daemon-util \
616         tools/kvm-ifup \
617         $(pkglib_python_scripts)
618
619 nodist_myexeclib_SCRIPTS = \
620         $(nodist_pkglib_python_scripts)
621
622 EXTRA_DIST = \
623         NEWS \
624         UPGRADE \
625         epydoc.conf.in \
626         pylintrc \
627         autotools/build-bash-completion \
628         autotools/build-rpc \
629         autotools/check-header \
630         autotools/check-python-code \
631         autotools/check-imports \
632         autotools/check-man-dashes \
633         autotools/check-man-warnings \
634         autotools/check-news \
635         autotools/check-tar \
636         autotools/check-version \
637         autotools/convert-constants \
638         autotools/docpp \
639         autotools/gen-coverage \
640         autotools/testrunner \
641         autotools/wrong-hardcoded-paths \
642         $(RUN_IN_TEMPDIR) \
643         daemons/daemon-util.in \
644         daemons/ganeti-cleaner.in \
645         $(pkglib_python_scripts) \
646         devel/upload.in \
647         tools/kvm-ifup.in \
648         $(docdot) \
649         $(docpng) \
650         $(docrst) \
651         doc/conf.py \
652         doc/html \
653         $(BUILT_EXAMPLES:%=%.in) \
654         doc/examples/ganeti.default \
655         doc/examples/ganeti.default-debug \
656         doc/examples/hooks/ethers \
657         doc/examples/gnt-debug/README \
658         doc/examples/gnt-debug/delay0.json \
659         doc/examples/gnt-debug/delay50.json \
660         test/lockperf.py \
661         test/testutils.py \
662         test/mocks.py \
663         $(dist_TESTS) \
664         $(TEST_FILES) \
665         man/footer.rst \
666         $(manrst) \
667         $(maninput) \
668         qa/qa-sample.json \
669         $(qa_scripts) \
670         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
671         $(HS_PROG_SRCS) \
672         htools/lint-hints.hs \
673         htools/cli-tests-defs.sh \
674         htools/offline-test.sh
675
676 man_MANS = \
677         man/ganeti.7 \
678         man/ganeti-cleaner.8 \
679         man/ganeti-confd.8 \
680         man/ganeti-listrunner.8 \
681         man/ganeti-masterd.8 \
682         man/ganeti-noded.8 \
683         man/ganeti-os-interface.7 \
684         man/ganeti-rapi.8 \
685         man/ganeti-watcher.8 \
686         man/gnt-backup.8 \
687         man/gnt-cluster.8 \
688         man/gnt-debug.8 \
689         man/gnt-group.8 \
690         man/gnt-instance.8 \
691         man/gnt-job.8 \
692         man/gnt-node.8 \
693         man/gnt-os.8 \
694         man/hail.1 \
695         man/hbal.1 \
696   man/hcheck.1 \
697         man/hinfo.1 \
698         man/hscan.1 \
699         man/hspace.1 \
700         man/htools.1
701
702 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
703 manhtml = $(patsubst %.rst,%.html,$(manrst))
704 mangen = $(patsubst %.rst,%.gen,$(manrst))
705 maninput = \
706         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
707         $(patsubst %.html,%.html.in,$(manhtml)) \
708         man/footer.man man/footer.html $(mangen)
709
710 TEST_FILES = \
711         test/data/bdev-drbd-8.0.txt \
712         test/data/bdev-drbd-8.3.txt \
713         test/data/bdev-drbd-disk.txt \
714         test/data/bdev-drbd-net-ip4.txt \
715         test/data/bdev-drbd-net-ip6.txt \
716         test/data/cert1.pem \
717         test/data/ip-addr-show-dummy0.txt \
718         test/data/ip-addr-show-lo-ipv4.txt \
719         test/data/ip-addr-show-lo-ipv6.txt \
720         test/data/ip-addr-show-lo-oneline-ipv4.txt \
721         test/data/ip-addr-show-lo-oneline-ipv6.txt \
722         test/data/ip-addr-show-lo-oneline.txt \
723         test/data/ip-addr-show-lo.txt \
724         test/data/proc_drbd8.txt \
725         test/data/proc_drbd80-emptyline.txt \
726         test/data/proc_drbd83.txt \
727         test/data/proc_drbd83_sync.txt \
728         test/data/proc_drbd83_sync_krnl2.6.39.txt \
729         test/data/kvm_1.0_help.txt \
730         test/data/kvm_0.15.90_help.txt \
731         test/data/kvm_0.12.5_help.txt \
732         test/data/kvm_0.9.1_help.txt \
733         test/data/sys_drbd_usermode_helper.txt \
734         test/data/htools/hail-alloc-drbd.json \
735         test/data/htools/hail-change-group.json \
736         test/data/htools/hail-invalid-reloc.json \
737         test/data/htools/hail-node-evac.json \
738         test/data/htools/hail-reloc-drbd.json \
739         test/data/htools/common-suffix.data \
740         test/data/htools/invalid-node.data \
741         test/data/htools/missing-resources.data \
742         test/data/htools/rapi/groups.json \
743         test/data/htools/rapi/info.json \
744         test/data/htools/rapi/instances.json \
745         test/data/htools/rapi/nodes.json \
746         test/data/ovfdata/compr_disk.vmdk.gz \
747         test/data/ovfdata/config.ini \
748         test/data/ovfdata/corrupted_resources.ovf \
749         test/data/ovfdata/empty.ini \
750         test/data/ovfdata/empty.ovf \
751         test/data/ovfdata/ganeti.mf \
752         test/data/ovfdata/ganeti.ovf \
753         test/data/ovfdata/gzip_disk.ovf \
754         test/data/ovfdata/new_disk.vmdk \
755         test/data/ovfdata/no_disk.ini \
756         test/data/ovfdata/no_disk_in_ref.ovf \
757         test/data/ovfdata/no_os.ini \
758         test/data/ovfdata/no_ovf.ova \
759         test/data/ovfdata/ova.ova \
760         test/data/ovfdata/second_disk.vmdk \
761         test/data/ovfdata/rawdisk.raw \
762         test/data/ovfdata/unsafe_path.ini \
763         test/data/ovfdata/virtualbox.ovf \
764         test/data/ovfdata/wrong_extension.ovd \
765         test/data/ovfdata/wrong_config.ini \
766         test/data/ovfdata/wrong_manifest.mf \
767         test/data/ovfdata/wrong_manifest.ovf \
768         test/data/ovfdata/wrong_ova.ova \
769         test/data/ovfdata/wrong_xml.ovf \
770         test/data/ovfdata/other/rawdisk.raw \
771         test/data/vgreduce-removemissing-2.02.02.txt \
772         test/data/vgreduce-removemissing-2.02.66-fail.txt \
773         test/data/vgreduce-removemissing-2.02.66-ok.txt \
774         test/data/vgs-missing-pvs-2.02.02.txt \
775         test/data/vgs-missing-pvs-2.02.66.txt \
776         test/import-export_unittest-helper \
777         test/gnt-cli.test \
778         test/ganeti-cli.test \
779         test/htools-balancing.test \
780         test/htools-basic.test \
781         test/htools-dynutil.test \
782         test/htools-excl.test \
783         test/htools-hail.test \
784         test/htools-hspace.test \
785         test/htools-invalid.test \
786         test/htools-multi-group.test \
787         test/htools-no-backend.test \
788         test/htools-rapi.test \
789         test/htools-single-group.test \
790         test/htools-text-backend.test
791
792 python_tests = \
793         doc/examples/rapi_testutils.py \
794         test/ganeti.asyncnotifier_unittest.py \
795         test/ganeti.backend_unittest.py \
796         test/ganeti.bdev_unittest.py \
797         test/ganeti.cli_unittest.py \
798         test/ganeti.client.gnt_cluster_unittest.py \
799         test/ganeti.client.gnt_instance_unittest.py \
800         test/ganeti.daemon_unittest.py \
801         test/ganeti.cmdlib_unittest.py \
802         test/ganeti.compat_unittest.py \
803         test/ganeti.confd.client_unittest.py \
804         test/ganeti.config_unittest.py \
805         test/ganeti.constants_unittest.py \
806         test/ganeti.errors_unittest.py \
807         test/ganeti.hooks_unittest.py \
808         test/ganeti.ht_unittest.py \
809         test/ganeti.http_unittest.py \
810         test/ganeti.hypervisor_unittest.py \
811         test/ganeti.hypervisor.hv_chroot_unittest.py \
812         test/ganeti.hypervisor.hv_fake_unittest.py \
813         test/ganeti.hypervisor.hv_kvm_unittest.py \
814         test/ganeti.hypervisor.hv_lxc_unittest.py \
815         test/ganeti.hypervisor.hv_xen_unittest.py \
816         test/ganeti.impexpd_unittest.py \
817         test/ganeti.jqueue_unittest.py \
818         test/ganeti.locking_unittest.py \
819         test/ganeti.luxi_unittest.py \
820         test/ganeti.masterd.instance_unittest.py \
821         test/ganeti.mcpu_unittest.py \
822         test/ganeti.netutils_unittest.py \
823         test/ganeti.objects_unittest.py \
824         test/ganeti.opcodes_unittest.py \
825         test/ganeti.ovf_unittest.py \
826         test/ganeti.qlang_unittest.py \
827         test/ganeti.query_unittest.py \
828         test/ganeti.rapi.baserlib_unittest.py \
829         test/ganeti.rapi.client_unittest.py \
830         test/ganeti.rapi.resources_unittest.py \
831         test/ganeti.rapi.rlib2_unittest.py \
832         test/ganeti.rapi.testutils_unittest.py \
833         test/ganeti.rpc_unittest.py \
834         test/ganeti.runtime_unittest.py \
835         test/ganeti.serializer_unittest.py \
836         test/ganeti.ssh_unittest.py \
837         test/ganeti.storage_unittest.py \
838         test/ganeti.tools.ensure_dirs_unittest.py \
839         test/ganeti.uidpool_unittest.py \
840         test/ganeti.utils.algo_unittest.py \
841         test/ganeti.utils.filelock_unittest.py \
842         test/ganeti.utils.hash_unittest.py \
843         test/ganeti.utils.io_unittest.py \
844         test/ganeti.utils.log_unittest.py \
845         test/ganeti.utils.mlock_unittest.py \
846         test/ganeti.utils.nodesetup_unittest.py \
847         test/ganeti.utils.process_unittest.py \
848         test/ganeti.utils.retry_unittest.py \
849         test/ganeti.utils.text_unittest.py \
850         test/ganeti.utils.wrapper_unittest.py \
851         test/ganeti.utils.x509_unittest.py \
852         test/ganeti.utils_unittest.py \
853         test/ganeti.workerpool_unittest.py \
854         test/qa.qa_config_unittest.py \
855         test/cfgupgrade_unittest.py \
856         test/docs_unittest.py \
857         test/pycurl_reset_unittest.py \
858         test/tempfile_fork_unittest.py
859 if HAS_FAKEROOT
860 python_tests += test/ganeti.utils.io_unittest-runasroot.py
861 endif
862
863 haskell_tests = htools/test
864
865 dist_TESTS = \
866         test/check-cert-expired_unittest.bash \
867         test/daemon-util_unittest.bash \
868         test/ganeti-cleaner_unittest.bash \
869         test/import-export_unittest.bash \
870         test/cli-test.bash \
871         $(python_tests)
872
873 nodist_TESTS =
874 check_SCRIPTS =
875
876 if WANT_HTOOLSTESTS
877 nodist_TESTS += $(haskell_tests)
878 dist_TESTS += htools/offline-test.sh
879 check_SCRIPTS += htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
880 endif
881
882 TESTS = $(dist_TESTS) $(nodist_TESTS)
883
884 # Environment for all tests
885 PLAIN_TESTS_ENVIRONMENT = \
886         PYTHONPATH=. \
887         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
888         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
889         $(RUN_IN_TEMPDIR)
890
891 # Environment for tests run by automake
892 TESTS_ENVIRONMENT = \
893         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
894
895 all_python_code = \
896         $(dist_sbin_SCRIPTS) \
897         $(python_scripts) \
898         $(pkglib_python_scripts) \
899         $(nodist_pkglib_python_scripts) \
900         $(python_tests) \
901         $(pkgpython_PYTHON) \
902         $(client_PYTHON) \
903         $(hypervisor_PYTHON) \
904         $(rapi_PYTHON) \
905         $(server_PYTHON) \
906         $(pytools_PYTHON) \
907         $(http_PYTHON) \
908         $(confd_PYTHON) \
909         $(masterd_PYTHON) \
910         $(impexpd_PYTHON) \
911         $(utils_PYTHON) \
912         $(watcher_PYTHON) \
913         $(noinst_PYTHON) \
914         $(qa_scripts)
915
916 srclink_files = \
917         man/footer.rst \
918         test/check-cert-expired_unittest.bash \
919         test/daemon-util_unittest.bash \
920         test/ganeti-cleaner_unittest.bash \
921         test/import-export_unittest.bash \
922         test/cli-test.bash \
923         htools/offline-test.sh \
924         htools/cli-tests-defs.sh \
925         $(all_python_code) \
926         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
927
928 check_python_code = \
929         $(BUILD_BASH_COMPLETION) \
930         $(CHECK_IMPORTS) \
931         $(CHECK_HEADER) \
932         $(DOCPP) \
933         $(all_python_code)
934
935 lint_python_code = \
936         ganeti \
937         ganeti/http/server.py \
938         $(dist_sbin_SCRIPTS) \
939         $(python_scripts) \
940         $(pkglib_python_scripts) \
941         $(BUILD_BASH_COMPLETION) \
942         $(CHECK_IMPORTS) \
943         $(CHECK_HEADER) \
944         $(DOCPP) \
945         $(PYTHON_BOOTSTRAP)
946
947 standalone_python_modules = \
948         lib/rapi/client.py \
949         tools/ganeti-listrunner
950
951 pep8_python_code = \
952         ganeti \
953         ganeti/http/server.py \
954         $(dist_sbin_SCRIPTS) \
955         $(python_scripts) \
956         $(pkglib_python_scripts) \
957         $(BUILD_BASH_COMPLETION) \
958         $(CHECK_HEADER) \
959         $(DOCPP) \
960         $(PYTHON_BOOTSTRAP) \
961         qa
962
963 test/daemon-util_unittest.bash: daemons/daemon-util
964
965 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
966
967 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
968         sed -f $(REPLACE_VARS_SED) < $< > $@
969         chmod +x $@
970
971 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
972         sed -f $(REPLACE_VARS_SED) < $< > $@
973         chmod u+x $@
974
975 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
976         sed -f $(REPLACE_VARS_SED) < $< > $@
977         chmod +x $@
978
979 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
980         sed -f $(REPLACE_VARS_SED) < $< > $@
981
982 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
983         sed -f $(REPLACE_VARS_SED) < $< > $@
984
985 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
986         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
987         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
988
989 doc/%.png: doc/%.dot
990         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
991         $(DOT) -Tpng -o $@ $<
992
993 man/footer.man: man/footer.rst
994         @test -n "$(PANDOC)" || \
995           { echo 'pandoc' not found during configure; exit 1; }
996         $(PANDOC) -f rst -t man -o $@ $<
997
998 man/footer.html: man/footer.rst
999         @test -n "$(PANDOC)" || \
1000           { echo 'pandoc' not found during configure; exit 1; }
1001         $(PANDOC) -f rst -t html -o $@ $<
1002
1003 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1004         lib/build/shell_example_lexer.py \
1005         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1006         @echo "Checking $< for hardcoded paths..."
1007         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1008           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1009           exit 1; \
1010         fi
1011         set -e ; \
1012         trap 'echo auto-removing $@; rm $@' EXIT; \
1013         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1014         trap - EXIT
1015
1016 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1017         @test -n "$(PANDOC)" || \
1018           { echo 'pandoc' not found during configure; exit 1; }
1019         set -o pipefail ; \
1020         trap 'echo auto-removing $@; rm $@' EXIT; \
1021         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1022           sed -e 's/\\@/@/g' > $@; \
1023         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1024         $(CHECK_MAN_DASHES) $@; \
1025         trap - EXIT
1026
1027
1028 man/%.html.in: man/%.gen man/footer.html
1029         @test -n "$(PANDOC)" || \
1030           { echo 'pandoc' not found during configure; exit 1; }
1031         set -o pipefail ; \
1032         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1033           sed -e 's/\\@/@/g' > $@
1034
1035 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
1036         sed -f $(REPLACE_VARS_SED) < $< > $@
1037
1038 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
1039         sed -f $(REPLACE_VARS_SED) < $< > $@
1040
1041 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
1042         sed -f $(REPLACE_VARS_SED) < $< > $@
1043
1044 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
1045         sed -f $(REPLACE_VARS_SED) < $< > $@
1046
1047 epydoc.conf: epydoc.conf.in Makefile
1048         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
1049
1050 vcs-version:
1051         if test -d .git; then \
1052           git describe > $@; \
1053         elif test ! -f $@ ; then \
1054           echo "Cannot auto-generate $@ file"; exit 1; \
1055         fi
1056
1057 .PHONY: clean-vcs-version
1058 clean-vcs-version:
1059         rm -f vcs-version
1060
1061 .PHONY: regen-vcs-version
1062 regen-vcs-version:
1063         set -e; \
1064         cd $(srcdir); \
1065         if test -d .git; then \
1066           $(MAKE) clean-vcs-version; \
1067           $(MAKE) vcs-version; \
1068         fi
1069
1070 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
1071         set -e; \
1072         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1073         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1074
1075 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1076         lib/constants.py lib/_autoconf.py lib/luxi.py \
1077         $(CONVERT_CONSTANTS) \
1078         | lib/_vcsversion.py
1079         set -e; \
1080         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1081
1082 lib/_autoconf.py: Makefile | lib/.dir
1083         set -e; \
1084         { echo '# This file is automatically generated, do not edit!'; \
1085           echo '#'; \
1086           echo ''; \
1087           echo '"""Build-time configuration for Ganeti.'; \
1088           echo '';\
1089           echo 'This file is autogenerated by the build process.'; \
1090           echo 'For any changes you need to re-run ./configure (and'; \
1091           echo 'not edit by hand).'; \
1092           echo ''; \
1093           echo '"""'; \
1094           echo ''; \
1095           echo '# pylint: disable=C0301,C0324'; \
1096           echo '# because this is autogenerated, we do not want'; \
1097           echo '# style warnings' ; \
1098           echo ''; \
1099           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1100           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1101           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1102           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1103           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1104           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1105           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1106           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1107           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1108           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1109           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1110           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1111           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1112           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1113           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1114           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1115           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1116           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1117           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1118           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1119           echo "KVM_PATH = '$(KVM_PATH)'"; \
1120           echo "IP_PATH = '$(IP_PATH)'"; \
1121           echo "SOCAT_PATH = '$(SOCAT)'"; \
1122           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1123           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1124           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1125           echo "TOOLSDIR = '$(toolsdir)'"; \
1126           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1127           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1128           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1129           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1130           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1131           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1132           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1133           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1134           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1135           echo "RAPI_USER = '$(RAPI_USER)'"; \
1136           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1137           echo "CONFD_USER = '$(CONFD_USER)'"; \
1138           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1139           echo "NODED_USER = '$(NODED_USER)'"; \
1140           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1141           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1142           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1143           if [ "$(HTOOLS)" ]; then \
1144             echo "HTOOLS = True"; \
1145           else \
1146             echo "HTOOLS = False"; \
1147           fi; \
1148           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1149           echo "PY_CONFD = $(PY_CONFD)"; \
1150           echo "HS_CONFD = $(HS_CONFD)"; \
1151           echo "XEN_CMD = '$(XEN_CMD)'"; \
1152         } > $@
1153
1154 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
1155         set -e; \
1156         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1157         { echo '# This file is automatically generated, do not edit!'; \
1158           echo '#'; \
1159           echo ''; \
1160           echo '"""Build-time VCS version number for Ganeti.'; \
1161           echo '';\
1162           echo 'This file is autogenerated by the build process.'; \
1163           echo 'For any changes you need to re-run ./configure (and'; \
1164           echo 'not edit by hand).'; \
1165           echo ''; \
1166           echo '"""'; \
1167           echo ''; \
1168           echo '# pylint: disable=C0301,C0324'; \
1169           echo '# because this is autogenerated, we do not want'; \
1170           echo '# style warnings' ; \
1171           echo ''; \
1172           echo "VCS_VERSION = '$$VCSVER'"; \
1173         } > $@
1174
1175 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1176         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1177
1178 $(REPLACE_VARS_SED): Makefile
1179         set -e; \
1180         { echo 's#@PREFIX@#$(prefix)#g'; \
1181           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1182           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1183           echo 's#@BINDIR@#$(bindir)#g'; \
1184           echo 's#@SBINDIR@#$(sbindir)#g'; \
1185           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1186           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1187           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1188           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1189           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1190           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1191           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1192           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1193           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1194           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1195           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1196           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1197           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1198           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1199           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1200           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1201           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1202           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1203           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1204         } > $@
1205
1206 # Using deferred evaluation
1207 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1208 daemons/ganeti-watcher: MODULE = ganeti.watcher
1209 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1210 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1211 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/%,%,$@)
1212
1213 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1214         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1215         set -e; \
1216         { echo '#!/usr/bin/python'; \
1217           echo '# This file is automatically generated, do not edit!'; \
1218           echo "# Edit $(MODULE) instead."; \
1219           echo; \
1220           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1221           echo; \
1222           echo '# pylint: disable=C0103'; \
1223           echo '# C0103: Invalid name'; \
1224           echo; \
1225           echo 'import sys'; \
1226           echo 'import $(MODULE) as main'; \
1227           echo; \
1228           echo '# Temporarily alias commands until bash completion'; \
1229           echo '# generator is changed'; \
1230           echo 'if hasattr(main, "commands"):'; \
1231           echo '  commands = main.commands # pylint: disable=E1101'; \
1232           echo 'if hasattr(main, "aliases"):'; \
1233           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1234           echo; \
1235           echo 'if __name__ == "__main__":'; \
1236           echo '  sys.exit(main.Main())'; \
1237         } > $@
1238         chmod u+x $@
1239
1240 $(HS_BUILT_TEST_HELPERS): Makefile
1241         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1242         set -e; \
1243         { echo '#!/bin/sh'; \
1244           echo '# This file is automatically generated, do not edit!'; \
1245           echo "# Edit Makefile.am instead."; \
1246           echo; \
1247           echo "HTOOLS=$(TESTROLE) exec ./htools/hpc-htools \"\$$@\""; \
1248         } > $@
1249         chmod u+x $@
1250
1251 # We need to create symlinks because "make distcheck" will not install Python
1252 # files when building.
1253 stamp-srclinks: Makefile | $(all_dirfiles)
1254         set -e; \
1255         for i in $(srclink_files); do \
1256                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1257                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1258                 fi; \
1259         done
1260         touch $@
1261
1262 .PHONY: ganeti
1263 ganeti:
1264         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1265
1266 .PHONY: check-dirs
1267 check-dirs: $(BUILT_SOURCES)
1268         @set -e; \
1269         find . -type d \( \( -name . \) -o \( \
1270                 -name .git -o \
1271                 -name autom4te.cache \
1272                 \) -prune -o -print \) | { \
1273                 error=; \
1274                 while read dir; do \
1275                         case "$$dir" in \
1276                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1277                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1278                         esac; \
1279                 done; \
1280                 for dir in $(DIRS); do \
1281                         if ! test -d "$$dir"; then \
1282                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1283                                 error=1; \
1284                         fi \
1285                 done; \
1286                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1287         }
1288
1289 .PHONY: check-local
1290 check-local: check-dirs $(BUILT_SOURCES)
1291         $(CHECK_PYTHON_CODE) $(check_python_code)
1292         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1293         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1294         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1295         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1296         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1297         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1298                 echo "Incorrect version in README, expected $$expver"; \
1299                 exit 1; \
1300         fi; \
1301         for file in doc/iallocator.rst doc/hooks.rst; do \
1302                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1303                         "Documents Ganeti version $$expver"; then \
1304                         echo "Incorrect version in $$file, expected $$expver"; \
1305                         exit 1; \
1306                 fi; \
1307         done
1308
1309 .PHONY: hs-check
1310 hs-check: htools/test htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
1311         @rm -f test.tix
1312         ./htools/test
1313         HBINARY="./htools/hpc-htools" ./htools/offline-test.sh
1314
1315 # E111: indentation is not a multiple of four
1316 # E261: at least two spaces before inline comment
1317 # E501: line too long (80 characters)
1318 PEP8_IGNORE = E111,E261,E501
1319
1320 # For excluding pep8 expects filenames only, not whole paths
1321 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1322
1323 LINT_TARGETS = pylint pylint-qa
1324 if HAS_PEP8
1325 LINT_TARGETS += pep8
1326 endif
1327 if HAS_HLINT
1328 LINT_TARGETS += hlint
1329 endif
1330
1331 .PHONY: lint
1332 lint: $(LINT_TARGETS)
1333
1334 .PHONY: pylint
1335 pylint: $(BUILT_SOURCES)
1336         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1337         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1338
1339 .PHONY: pylint-qa
1340 pylint-qa: $(BUILT_SOURCES)
1341         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1342         cd $(top_srcdir)/qa && \
1343           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1344           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1345
1346 .PHONY: pep8
1347 pep8: $(BUILT_SOURCES)
1348         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1349         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1350                 --repeat $(pep8_python_code)
1351
1352 .PHONY: hlint
1353 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1354         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1355         if tty -s; then C="-c"; else C=""; fi; \
1356         $(HLINT) --report=doc/hs-lint.html --cross $$C \
1357           --ignore "Use first" \
1358           --ignore "Use comparing" \
1359           --ignore "Use on" \
1360           --ignore "Reduce duplication" \
1361           --hint htools/lint-hints \
1362           $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
1363
1364 # a dist hook rule for updating the vcs-version file; this is
1365 # hardcoded due to where it needs to build the file...
1366 dist-hook:
1367         $(MAKE) regen-vcs-version
1368         rm -f $(top_distdir)/vcs-version
1369         cp -p $(srcdir)/vcs-version $(top_distdir)
1370
1371 # a distcheck hook rule for catching revision control directories
1372 distcheck-hook:
1373         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1374                 echo "Found revision control files in final archive." 1>&2; \
1375                 exit 1; \
1376         fi
1377         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1378                 echo "Found Python byte code in final archive." 1>&2; \
1379                 exit 1; \
1380         fi
1381         if find $(top_distdir) -name '*~' | grep .; then \
1382                 echo "Found backup files in final archive." 1>&2; \
1383                 exit 1; \
1384         fi
1385 # Empty files or directories should not be distributed. They can cause
1386 # unnecessary warnings for packagers. Directories used by automake during
1387 # distcheck must be excluded.
1388         if find $(top_distdir) -empty -and -not \( \
1389                         -path $(top_distdir)/_build -or \
1390                         -path $(top_distdir)/_inst \) | grep .; then \
1391                 echo "Found empty files or directories in final archive." 1>&2; \
1392                 exit 1; \
1393         fi
1394         if test -n "$(BUILD_RELEASE)" && \
1395            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1396                 echo "Found unreleased version in NEWS." >&2; \
1397                 exit 1; \
1398         fi
1399
1400 # When building a release, stricter checks should be used
1401 distcheck-release dist-release: export BUILD_RELEASE = 1
1402 distcheck-release: distcheck
1403
1404 dist-release: dist
1405         set -e; \
1406         for i in $(DIST_ARCHIVES); do \
1407                 echo -n "Checking $$i ... "; \
1408                 autotools/check-tar < $$i; \
1409                 echo OK; \
1410         done
1411
1412 install-exec-local:
1413         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1414           "$(DESTDIR)${localstatedir}/log/ganeti" \
1415           "$(DESTDIR)${localstatedir}/run/ganeti"
1416
1417 # To avoid conflicts between directory names and other targets, a file inside
1418 # the directory is used to ensure its existence.
1419 %.dir:
1420         @mkdir_p@ $* && touch $@
1421
1422 .PHONY: apidoc
1423 if WANT_HTOOLSAPIDOC
1424 apidoc: py-apidoc hs-apidoc
1425 else
1426 apidoc: py-apidoc
1427 endif
1428
1429 .PHONY: py-apidoc
1430 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1431         $(RUN_IN_TEMPDIR) epydoc -v \
1432                 --conf $(CURDIR)/epydoc.conf \
1433                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1434
1435 .PHONY: hs-apidoc
1436 hs-apidoc: $(HS_BUILT_SRCS)
1437         @test -n "$(HSCOLOUR)" || \
1438             { echo 'HsColour' not found during configure; exit 1; }
1439         @test -n "$(HADDOCK)" || \
1440             { echo 'haddock' not found during configure; exit 1; }
1441         rm -rf $(APIDOC_HS_DIR)/*
1442         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1443         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1444         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1445         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1446         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1447         set -e ; \
1448         cd htools; \
1449         if [ "$(HTOOLS_NOCURL)" ]; \
1450         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1451         else OPTGHC=""; \
1452         fi; \
1453         if [ "$(HTOOLS_PARALLEL3)" ]; \
1454         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1455         fi; \
1456         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1457         for file in $$RELSRCS; do \
1458                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1459                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1460         done ; \
1461         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1462                 -t ganeti-htools -p haddock-prologue \
1463                 --source-module="%{MODULE/.//}.html" \
1464                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1465                 $$OPTGHC \
1466                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1467
1468 .PHONY: TAGS
1469 TAGS: $(BUILT_SOURCES)
1470         rm -f TAGS
1471         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1472           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1473           -path './qa/*.py' | \
1474           etags -l python -
1475
1476 .PHONY: coverage
1477 if WANT_HTOOLS
1478 coverage: py-coverage hs-coverage
1479 else
1480 coverage: py-coverage
1481 endif
1482
1483 .PHONY: py-coverage
1484 py-coverage: $(BUILT_SOURCES) $(python_tests)
1485         set -e; \
1486         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1487         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1488         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1489         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1490         $(python_tests)
1491
1492 .PHONY: hs-coverage
1493 hs-coverage: $(haskell_tests) htools/hpc-htools
1494         rm -f *.tix
1495         $(MAKE) hs-check
1496         @mkdir_p@ $(COVERAGE_HS_DIR)
1497         hpc combine $(HPCEXCL) test.tix hpc-htools.tix > coverage-htools.tix
1498         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1499         hpc report coverage-htools.tix
1500         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1501
1502 # Special "kind-of-QA" target for htools, needs special setup (all
1503 # tools compiled with -fhpc)
1504 .PHONY: live-test
1505 live-test: all
1506         set -e ; \
1507         cd htools; \
1508         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1509         rm -f *.tix *.mix; \
1510         ./live-test.sh; \
1511         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1512           --output=live-test.tix ; \
1513         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1514         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1515                 --srcdir=.. $(HPCEXCL) ; \
1516         hpc report --srcdir=.. live-test $(HPCEXCL)
1517
1518 commit-check: distcheck lint apidoc
1519
1520 -include ./Makefile.local
1521
1522 # vim: set noet :